package hero.user;
/**
*
* Bonita
* Copyright (C) 1999 Bull S.A.
* Bull 68 route de versailles  78434 Louveciennes Cedex France
* Further information: bonita@objectweb.org
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or any later version.
*
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
* USA
*
*
--------------------------------------------------------------------------
* $Id: JIAPUserBase.java,v 1.3 2005/11/25 12:23:37 blachonm Exp $
*
--------------------------------------------------------------------------
*/

import hero.user.UserBaseException;

import javax.naming.Context;
import javax.naming.InitialContext;

import java.util.Collection;
import java.util.Map;
import java.util.Properties;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.ArrayList;

import jiap.manager.User;
import jiap.manager.UserManager;
import jiap.manager.UserManagerHome;
import jiap.manager.UserManagerUtil;

public class JIAPUserBase implements UserBase {

	private String url;
	private String user;
	private String password;
	private String driver;
	private UserManager um;

	public JIAPUserBase() {
		UserManagerHome umh;
		/*
		Properties props = new Properties();

		props.put("java.naming.factory.initial","org.objectweb.carol.jndi.spi.MultiOrbInitialContextFactory");
		props.put("java.naming.factory.url.pkgs","org.objectweb.jonas.naming");
		//props.put("java.naming.provider.url", "rmi://129.183.101.128:1099");
		props.put("java.naming.provider.url", "rmi://localhost:1099");

		Context initialContext = null;
		try {
		     initialContext = new InitialContext(props);
		} catch (Exception e) {e.printStackTrace();
		      System.err.println("Cannot get initial context for JNDI: " + e);
		}
		*/
		try{
			//umh = UserManagerUtil.getHome(props);
			umh = UserManagerUtil.getHome();
			um=umh.create();
		}catch(Exception e){e.printStackTrace();}

	}

	/* (non-Javadoc)
	 * @see hero.util.user.UserBase#getUserName(java.lang.String)
	 */
	public String getUserName(String userId) throws UserBaseException {
		return userId;
	}

	/* (non-Javadoc)
	 * @see hero.util.user.UserBase#getUserInfos(java.lang.String)
	 */
	public Map getUserInfos(String userId) throws UserBaseException {
		Hashtable uinfos=new Hashtable();
		try {
			User user= um.getUser(userId);
			uinfos.put("name",userId);
			if (user.getPassword() != null){
				uinfos.put("password",user.getPassword());
			}
			else{
				uinfos.put("password","titi");
			}
			uinfos.put("email",user.getEmail());
			uinfos.put("jabber","jabber");
			return uinfos;
		} catch (Exception ne) {
				throw new UserBaseException(ne.getMessage());
		}
	}

	/* (non-Javadoc)
	 * @see hero.util.user.UserBase#getUsers()
	 */
	public Collection getUsers() throws UserBaseException{
		Collection coUsers = null;
		ArrayList coMaps = new ArrayList();
		try {
			coUsers = um.getUsers();
			Iterator it = coUsers.iterator();
			while (it.hasNext()){
				User user = (User)it.next();
				Hashtable uinfos=new Hashtable();
				uinfos.put("name",user.getName());
				//With Ldap user.getPassword() == null
				///uinfos.put("password",user.getPassword());
				uinfos.put("email",user.getEmail());
				uinfos.put("jabber","jabber");
				coMaps.add(uinfos);
			}
			return coMaps;
		} catch (Exception ne) {ne.printStackTrace();
				throw new UserBaseException(ne.getMessage());
		}
	}

	/* (non-Javadoc)
	 * @see hero.util.user.UserBase#handle(java.lang.String)
	 */
	public boolean handle(String userId) throws UserBaseException {
		// TODO Auto-generated method stub
		return false;
	}
	/* (non-Javadoc)
	 * @see hero.util.user.UserBase#isMutable()
	 */
	public boolean isMutable() {
		return true;
	}
	/* (non-Javadoc)
	 * @see hero.util.user.UserBase#create(java.lang.String, java.lang.String, java.lang.String, java.lang.String, java.util.Map)
	 */
	public void create(String userId, String password, String userName,	String userEmail, Map userInfos) throws UserBaseException,
			ImmutableException {
	}
	/* (non-Javadoc)
	 * @see hero.util.user.UserBase#edit(java.lang.String, java.lang.String, java.lang.String, java.lang.String, java.util.Map)
	 */
	public void edit(String userId, String password, String userName,
			String userEmail, Map userInfos) throws UserBaseException,
			ImmutableException {
		// TODO Auto-generated method stub
	}
	/* (non-Javadoc)
	 * @see hero.util.user.UserBase#deleteUser(java.lang.String)
	 */
	public void deleteUser(String userId) throws UserBaseException,
			ImmutableException {
		// TODO Auto-generated method stub
	}
}
